<template>
<div>
  <form>
    <div class="wrapper">
      <div class="infos">
        <label>Nom</label>
        <b-form-input type="text" v-model="nom"/>
        <label>Longitude</label>
        <b-form-input type="text" v-model="longitude"/>
        <label>Latitude</label>
        <b-form-input type="text" v-model="latitude"/>

      </div>
      <div class="description">
        <label>Description</label>
        <b-form-textarea
          v-model="description"
          id="textarea"
          placeholder="Enter something..."
          rows="3"
          max-rows="6">
        </b-form-textarea>
      </div>

    </div>
      <div class="custom-file">
        <input @change="onFileChanged"  type="file" class="custom-file-input" id="hFichier" name="hFichier" lang="fr" accept=".jpg,.jpeg,.gif,.png" />
        <label class="custom-file-label" for="hFichier">Photo</label>
      </div>
      <b-button class="mt-5" v-on:click="newSpot">Envoyer</b-button>
      <div v-if="succeossText">
        {{ successText }}
      </div>
<!--
    <div class="form-row">
      <div class="form-group col-md-6">
        <label>Nom</label>
        <b-form-input type="text" v-model="nom"/>
      </div>
      <div class="form-group col-md-6">
        <label>Description</label>
        <b-form-textarea
          v-model="description"
          id="textarea"
          placeholder="Enter something..."
          rows="3"
          max-rows="6">
        </b-form-textarea>
      </div>
    </div>

    <div class="form-row">
      <div class="form-group col-md-6">
        <label>Longitude</label>
        <b-form-input type="text" v-model="longitude"/>
      </div>
      <div class="form-group col-md-6">
        <label>Latitude</label>
        <b-form-input type="text" v-model="latitude"/>
      </div>
    </div>
      <div class="custom-file">
        <b-form-input type="file" class="custom-file-input" id="hFichier" name="hFichier" lang="fr" accept=".jpg,.jpeg,.gif,.png" />
        <label class="custom-file-label" for="hFichier">Photo</label>
      </div>
      <div v-if="successText">
        {{ successText }}
      </div>

      <b-button class="mt-5" v-on:click="newSpot">Envoyer</b-button> -->

  </form>
</div>
</template>

<script>
import Cookies from 'js-cookie'

export default {
  name: 'addSpot',
  data () {
    return {
      nom: '',
      longitude: '',
      latitude: '',
      description: '',
      photo: '',
      errorText: '',
      successText: ''
    }
  },

  methods: {
    onFileChanged (event) {
      this.photo = event.target.files
    },
    newSpot () {
      const token = Cookies.get('token')

      const reader = new FileReader()

      var file = this.photo[0]
      // encode dataURI
      reader.readAsDataURL(file)

      reader.addEventListener('load', async () => {
        console.log('encoded file: ', reader.result)

        const requestOptionsUpload = {
          method: 'POST',
          headers: { 'Content-Type': 'application/json', Authorization: 'JWT ' + token },
          body: JSON.stringify({
            uri: reader.result
          })
        }
        let idPhoto = null
        await fetch('/uploads', requestOptionsUpload)
          .then(response => {
            return response.json()
          })
          .then(json => {
            idPhoto = json.id
          })

        const requestOptions = {
          method: 'POST',
          headers: { 'Content-Type': 'application/json', Authorization: 'JWT ' + token },
          body: JSON.stringify({
            nom: this.nom,
            longitude: this.longitude,
            latitude: this.latitude,
            description: this.description,
            photo: idPhoto
          })
        }
        fetch('/spot', requestOptions)
          .then(async response => {
          // On a une erreur de mot de passe ou de mail
            if (response.status !== 200) {
              this.errorText = await response.text()
            } else {
            // Rediriger vers une page
              this.successText = 'Spot créé'
            // window.location.href = '#/login'
            }
            console.log(response)
          })
      }, false)
    }
  }
}

</script>

<style scoped>

.wrapper {
  margin: auto;
  display: flex;
  width: 100%;
  text-align: left;
}

.infos {
  flex: 1 0 0;
  margin-right: 10px;
  margin-bottom: 10px;
}
.description {
  flex: 1 0 0;
  margin-left: 10px;
  margin-bottom: 10px;
}

input, textarea {
    border: 1px solid #383838;
}

button {
  width: 50% !important;
}

#container{
  width:30%;
  margin:0 auto;
  margin-top:5%;
}

h1{
  width: 60%;
  margin: 0 auto;
  padding-bottom: 100px;
  text-align: center;
  font-size: 5em;
}

form {
  /* Uniquement centrer le formulaire sur la page /
  margin: 0 auto;
  width: 100%;
  / Encadré pour voir les limites du formulaire /
  padding: 60px;
  border: 1px solid #42b983;
  background:#fff;
  border-radius: 1em;
}

label {
  / Pour être sûrs que toutes les étiquettes ont même taille et sont correctement alignées /
  font-size: 2.5em;
}

input {
  / Pour s'assurer que tous les champs texte ont la même police.
     Par défaut, les textarea ont une police monospace /
  font: 2em sans-serif;
  / Pour que tous les champs texte aient la même dimension */
  width: 100%;
  box-sizing: border-box;
  margin: 20px 0;
  padding: 20px 20px;
}

button {
  background-color: #42b983;
  color: white;
  padding: 25px 20px;
  width: 100%;
  font-size: 2.5em;
}

button:hover{
  background-color: white;
  color: #42b983;
  border: 1px solid #42b983
}
</style>
